/* application source */
var canvas = document.getElementById("skeletonsCanvas");
var context = canvas.getContext("2d");

	var channel_max = 10;										// number of channels
	audiochannels = new Array();
	for (a=0;a<channel_max;a++) {									// prepare the channels
		audiochannels[a] = new Array();
		audiochannels[a]['channel'] = new Audio();						// create a new audio object
		audiochannels[a]['finished'] = -1;							// expected end time for this channel
	}
	function play_multi_sound(s) {
		for (a=0;a<audiochannels.length;a++) {
			thistime = new Date();
			if (audiochannels[a]['finished'] < thistime.getTime()) {			// is this channel finished?
				audiochannels[a]['finished'] = thistime.getTime() + document.getElementById(s).duration*1000;
				audiochannels[a]['channel'].src = document.getElementById(s).src;
				audiochannels[a]['channel'].load();
				audiochannels[a]['channel'].play();
				break;
			}
		}
	}


function getSkeletons(jsonObject){
	
  if (context == null) {
      return;
  }
  
  context.clearRect(0, 0, canvas.width, canvas.height);

  for (var i = 0; i < jsonObject.skeletons.length; i++) {
	var headZ = 0;
    var hipZ = 0;

    for (var j = 0; j < jsonObject.skeletons[i].joints.length; j++) 
    {
      var joint = jsonObject.skeletons[i].joints[j];
      
      // Draw!!!
      context.fillStyle = "#FF0000";
      context.beginPath();
      context.arc(joint.x, joint.y, 10, 0, Math.PI * 2, true);
      context.closePath();
      context.fill();
		
      // joint.name  values
      		//head
      		//hipleft
      
     }
	}
}

              
function msgFromArduino(value){
	console.debug('From Arduino: ' + value);
  $('span').html(value);
}

function grip() {
  $('span').html('Mano Cerrada');
	console.debug('Grip!');  
  play_multi_sound('multiaudio3');
   $.get('http://192.168.1.34/open_B.act', function(responseText) {
    //setEventMsg("Door Open... :)");
});
  
  $.get('http://192.168.1.112/blue.act', function(responseText) {
    //setEventMsg("Door Open... :)");
});
  
}

function release() {
  $('span').html('Mano Abierta');
  console.debug('Release');
  play_multi_sound('multiaudio4');
  $.get('http://192.168.1.112/off.act', function(responseText) {
    //setEventMsg("Door Open... :)");
});
  
  
}

function next() {
  $('span').html('Siguiente');
	console.debug('Next!');  
}

function prior() {
  $('span').html('Anterior');
	console.debug('Prior');
}

function noUser(){
  $('span').html('No Hay Nadie');
  console.debug('No User :(');  
//sendToArduino('0');
  
      $.get('http://192.168.1.39/off.act', function(responseText) {
    //setEventMsg("Door Open... :)");
});
  
  
  
}

function newUser() {
  $('span').html('Hay Alguien');
  console.debug('New User :)');  
  //sendToArduino('1');
  play_multi_sound('multiaudio5');
  
      $.get('http://192.168.1.39/on.act', function(responseText) {
    //setEventMsg("Door Open... :)");
});

  
}

function changeHandNone() {
  $('span').html('Sin Mano');
	console.debug('Hand None');  
}

function changeHandRight() {
  $('span').html('Mano Derecha');
  console.debug('Hand Right');  
  play_multi_sound('multiaudio1');
}

function changeHandLeft() {
  $('span').html('Mano Izquierda');
  console.debug('Hand Left');  
  play_multi_sound('multiaudio2');
}






(function(){

 var draw, h, hash, hsl, l, lock, s, wheelEvent;

  h = ~~(Math.random() * 360);

  s = 50;

  l = 50;

  lock = false;

  draw = function() {
    var hcl, hsl, lab, rgb;
    if (lock === false) {
      $('b').hide();
      hsl = new d3.hsl(h, s / 100.0, l / 100.0);
      hcl = new d3.hcl(hsl);
      rgb = new d3.rgb(hsl);
      lab = new d3.lab(hsl);
      //$('span').html("");
      //$('span').append(hsl.toString());
      //$('span').append("<br /> rgb(" + rgb.r + ", " + rgb.g + ", " + rgb.b + ")");
      //$('span').append("<br /> hsl(" + h + ", " + s + "%, " + l + "%)");
      //$('span').append("<br /> hcl(" + ((~~hcl.h + 360) % 360) + ", " + (hcl.c.toFixed(2)) + "%, " + (hcl.l.toFixed(2)) + "%)");
      //$('span').append("<br /> lab(" + (lab.l.toFixed(0)) + ", " + (lab.a.toFixed(0)) + ", " + (lab.b.toFixed(0)) + ")");
      $('body').css("background-color", "hsl(" + h + ", " + s + "%, " + l + "%)");
      //$('span').html(rgb.r + " " + rgb.g + " " + rgb.b);
      //sendToArduino(rgb.r + " " + rgb.g + " " + rgb.b);
      return $('body').css("color", "rgb(" + (Math.min(rgb.r + 96, 255)) + ", " + (Math.min(rgb.g + 96, 255)) + ", " + (Math.min(rgb.b + 96, 255)) + ")");
    } else {
      return $('b').show();
    }
  };

  $(window).mousemove(function(e) {
    var maxX, maxY, x, y;
    maxX = window.innerWidth;
    maxY = window.innerHeight;
    x = e.pageX;
    y = e.pageY;
    h = ~~(x / maxX * 360);
    l = ~~(y / maxY * 10000) / 100;
    draw();
  });

  wheelEvent = function(e) {
    var delta;
    delta = (e.wheelDelta || e.detail || e.originalEvent.wheelDelta || e.originalEvent.detail) > 0 ? 1 : -1;
    s = Math.max(0, Math.min(100, s + delta * 5));
    draw();
  };

  $('body').bind("mousewheel", wheelEvent);

  $('body').bind("DOMMouseScroll", wheelEvent);

  $('b').click(function() {
   // return lock = false;
  });

  $(window).click(function() {
    //return lock = true;
  });

  $(window).dblclick(function() {
    //return lock = false;
  });

  $('b').mouseenter(function() {
    return $('b').html('w');
  });

  $('b').mouseleave(function() {
    return $('b').html('W');
  });

  hash = location.hash.indexOf('(') > 0 ? location.hash.substr(1) : location.hash;

  if (hash.length > 0) {
    hsl = new d3.hsl(hash);
    h = hsl.h;
    s = hsl.s * 100;
    l = hsl.l * 100;
    draw();
    lock = true;
  } else {
    draw();
  }

}).call(this);